> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://developers.beehiiv.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://developers.beehiiv.com/_mcp/server.

# List poll responses <Badge intent="info" minimal outlined>OAuth Scope: polls:read</Badge>

GET https://api.beehiiv.com/v2/publications/{publicationId}/polls/{pollId}/responses

Retrieve all individual subscriber responses for a specific poll with cursor-based pagination. Use this endpoint for large datasets instead of the `expand[]=poll_responses` parameter on the poll show endpoint.

Reference: https://developers.beehiiv.com/api-reference/polls/list-responses

## Authentication

- `Authorization` header (bearer token, required) — Bearer authentication of the form `Bearer <token>`, where token is your auth token.

## Request

### Path parameters

- `publicationId` (string, required) — The prefixed ID of the publication object
- `pollId` (string, required) — The prefixed ID of the poll object

### Query parameters

- `limit` (integer, optional) — A limit on the number of objects to be returned. The limit can range between 1 and 100, and the default is 10.
- `cursor` (string, optional) — **Cursor-based pagination (recommended)**: Use this opaque cursor token to fetch the next page of results.
- `page` (integer, optional) — **Offset-based pagination (deprecated)**: Page number for offset-based pagination.
- `order_by` (enum, optional, default: created) — The field that the results are sorted by. Defaults to created.
  - Allowed values: `created`
- `direction` (enum, optional, default: asc) — The direction that the results are sorted in. Defaults to asc. `asc` - Ascending, sorts from smallest to largest. `desc` - Descending, sorts from largest to smallest.
  - Allowed values: `asc`, `desc`
- `expand[]` (list of enum, optional) — Optionally expand the response to include additional data. `post` - Returns the post title and publication date for the post where each response was collected.
  - Allowed values: `post`
- `post_id` (string, optional) — Filter to only return responses collected via the specified post. Accepts a prefixed post ID (e.g. `post_abc123`).

## Response

### 200

OK

- `data` (list of PollResponseItem, required) — An array of poll responses.
- `limit` (integer, optional) — The limit placed on the results. If no limit was specified in the request, this defaults to 10.
- `page` (integer, optional, default: 1) — **Offset pagination only**: The page number the results are from. Only present when using deprecated offset-based pagination.
- `total_pages` (integer, optional) — **Offset pagination only**: The total number of pages. Only present when using deprecated offset-based pagination.
- `has_more` (boolean, optional) — **Cursor pagination only**: Indicates whether there are more results available after the current page.
- `next_cursor` (string, optional) — **Cursor pagination only**: The cursor token to use for fetching the next page of results.
- `total_results` (integer, optional) — The total number of results from all pages.

## Errors

### 401 Unauthorized Error

Unauthorized. The API key or OAuth access token is missing, invalid, or expired.

- `status` (integer, required)
- `statusText` (string, required)
- `errors` (list of ErrorDetail, required)

### 404 Not Found Error

Resource Not Found

- `status` (integer, required)
- `statusText` (string, required)
- `errors` (list of ErrorDetail, required)

### 429 Too Many Requests Error

Rate Limit Exceeded

- `status` (integer, required)
- `statusText` (string, required)
- `errors` (list of ErrorDetail, required)

### 500 Internal Server Error

Internal Server Error

- `status` (integer, required)
- `statusText` (string, required)
- `errors` (list of ErrorDetail, required)

## Types

### PollResponseItem

- `id` (string, required) — The unique identifier of the poll response.
- `subscription_deleted` (boolean, required) — Whether the associated subscription has been deleted or permanently removed.
- `poll_choice_id` (string, required) — The UUID of the poll choice selected.
- `created_at` (integer, required) — The time the response was created. Measured in seconds since the Unix epoch.
- `subscription_id` (string, optional) — The prefixed ID of the subscription that responded. Null if the subscription has been permanently deleted.
- `poll_choice_label` (string, optional) — The text label of the poll choice selected.
- `extended_feedback` (string, optional) — Optional extended feedback provided by the subscriber.
- `post_id` (string, optional) — The prefixed ID of the post where the response was collected. Only included when `expand[]=post` is specified.
- `post_title` (string, optional) — The title of the post where the response was collected. Only included when `expand[]=post` is specified.
- `post_publish_date` (integer, optional) — The scheduled publication date of the post where the response was collected. Measured in seconds since the Unix epoch. Only included when `expand[]=post` is specified. Null if the post is not yet scheduled.

### ErrorDetail

- `message` (string, required)
- `code` (string, required)

## Examples

### Example 1

**Response**

```json
{
  "data": [
    {
      "id": "00000000-0000-0000-0000-000000000010",
      "subscription_deleted": false,
      "poll_choice_id": "00000000-0000-0000-0000-000000000001",
      "created_at": 1666800100,
      "subscription_id": "sub_00000000-0000-0000-0000-000000000001",
      "poll_choice_label": "Red",
      "extended_feedback": "I love red!"
    },
    {
      "id": "00000000-0000-0000-0000-000000000011",
      "subscription_deleted": false,
      "poll_choice_id": "00000000-0000-0000-0000-000000000002",
      "created_at": 1666800200,
      "subscription_id": "sub_00000000-0000-0000-0000-000000000002",
      "poll_choice_label": "Blue",
      "extended_feedback": null
    }
  ],
  "limit": 10,
  "has_more": true,
  "next_cursor": "eyJ0aW1lc3RhbXAiOiIyMDI0LTA3LTAyVDE3OjMwOjAwLjAwMDAwMFoifQ=="
}
```

**SDK Code**

```python
import requests

url = "https://api.beehiiv.com/v2/publications/pub_00000000-0000-0000-0000-000000000000/polls/poll_00000000-0000-0000-0000-000000000000/responses"

querystring = {"limit":"10"}

headers = {"Authorization": "Bearer <token>"}

response = requests.get(url, headers=headers, params=querystring)

print(response.json())
```

```javascript
const url = 'https://api.beehiiv.com/v2/publications/pub_00000000-0000-0000-0000-000000000000/polls/poll_00000000-0000-0000-0000-000000000000/responses?limit=10';
const options = {method: 'GET', headers: {Authorization: 'Bearer <token>'}};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"net/http"
	"io"
)

func main() {

	url := "https://api.beehiiv.com/v2/publications/pub_00000000-0000-0000-0000-000000000000/polls/poll_00000000-0000-0000-0000-000000000000/responses?limit=10"

	req, _ := http.NewRequest("GET", url, nil)

	req.Header.Add("Authorization", "Bearer <token>")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api.beehiiv.com/v2/publications/pub_00000000-0000-0000-0000-000000000000/polls/poll_00000000-0000-0000-0000-000000000000/responses?limit=10")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Get.new(url)
request["Authorization"] = 'Bearer <token>'

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.get("https://api.beehiiv.com/v2/publications/pub_00000000-0000-0000-0000-000000000000/polls/poll_00000000-0000-0000-0000-000000000000/responses?limit=10")
  .header("Authorization", "Bearer <token>")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('GET', 'https://api.beehiiv.com/v2/publications/pub_00000000-0000-0000-0000-000000000000/polls/poll_00000000-0000-0000-0000-000000000000/responses?limit=10', [
  'headers' => [
    'Authorization' => 'Bearer <token>',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://api.beehiiv.com/v2/publications/pub_00000000-0000-0000-0000-000000000000/polls/poll_00000000-0000-0000-0000-000000000000/responses?limit=10");
var request = new RestRequest(Method.GET);
request.AddHeader("Authorization", "Bearer <token>");
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = ["Authorization": "Bearer <token>"]

let request = NSMutableURLRequest(url: NSURL(string: "https://api.beehiiv.com/v2/publications/pub_00000000-0000-0000-0000-000000000000/polls/poll_00000000-0000-0000-0000-000000000000/responses?limit=10")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "GET"
request.allHTTPHeaderFields = headers

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```

### With post context expansion

**Response**

```json
{
  "data": [
    {
      "id": "00000000-0000-0000-0000-000000000010",
      "subscription_deleted": false,
      "poll_choice_id": "00000000-0000-0000-0000-000000000001",
      "created_at": 1666800100,
      "subscription_id": "sub_00000000-0000-0000-0000-000000000001",
      "poll_choice_label": "Red",
      "extended_feedback": "I love red!",
      "post_id": "post_00000000-0000-0000-0000-000000000000",
      "post_title": "July 4th Edition",
      "post_publish_date": 1666800000
    }
  ],
  "limit": 10,
  "has_more": false,
  "next_cursor": null
}
```

**SDK Code**

```python With post context expansion
import requests

url = "https://api.beehiiv.com/v2/publications/pub_00000000-0000-0000-0000-000000000000/polls/poll_00000000-0000-0000-0000-000000000000/responses"

querystring = {"expand[]":"[\"post\"]"}

headers = {"Authorization": "Bearer <token>"}

response = requests.get(url, headers=headers, params=querystring)

print(response.json())
```

```javascript With post context expansion
const url = 'https://api.beehiiv.com/v2/publications/pub_00000000-0000-0000-0000-000000000000/polls/poll_00000000-0000-0000-0000-000000000000/responses?expand%5B%5D=%5B%22post%22%5D';
const options = {method: 'GET', headers: {Authorization: 'Bearer <token>'}};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go With post context expansion
package main

import (
	"fmt"
	"net/http"
	"io"
)

func main() {

	url := "https://api.beehiiv.com/v2/publications/pub_00000000-0000-0000-0000-000000000000/polls/poll_00000000-0000-0000-0000-000000000000/responses?expand%5B%5D=%5B%22post%22%5D"

	req, _ := http.NewRequest("GET", url, nil)

	req.Header.Add("Authorization", "Bearer <token>")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby With post context expansion
require 'uri'
require 'net/http'

url = URI("https://api.beehiiv.com/v2/publications/pub_00000000-0000-0000-0000-000000000000/polls/poll_00000000-0000-0000-0000-000000000000/responses?expand%5B%5D=%5B%22post%22%5D")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Get.new(url)
request["Authorization"] = 'Bearer <token>'

response = http.request(request)
puts response.read_body
```

```java With post context expansion
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.get("https://api.beehiiv.com/v2/publications/pub_00000000-0000-0000-0000-000000000000/polls/poll_00000000-0000-0000-0000-000000000000/responses?expand%5B%5D=%5B%22post%22%5D")
  .header("Authorization", "Bearer <token>")
  .asString();
```

```php With post context expansion
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('GET', 'https://api.beehiiv.com/v2/publications/pub_00000000-0000-0000-0000-000000000000/polls/poll_00000000-0000-0000-0000-000000000000/responses?expand%5B%5D=%5B%22post%22%5D', [
  'headers' => [
    'Authorization' => 'Bearer <token>',
  ],
]);

echo $response->getBody();
```

```csharp With post context expansion
using RestSharp;

var client = new RestClient("https://api.beehiiv.com/v2/publications/pub_00000000-0000-0000-0000-000000000000/polls/poll_00000000-0000-0000-0000-000000000000/responses?expand%5B%5D=%5B%22post%22%5D");
var request = new RestRequest(Method.GET);
request.AddHeader("Authorization", "Bearer <token>");
IRestResponse response = client.Execute(request);
```

```swift With post context expansion
import Foundation

let headers = ["Authorization": "Bearer <token>"]

let request = NSMutableURLRequest(url: NSURL(string: "https://api.beehiiv.com/v2/publications/pub_00000000-0000-0000-0000-000000000000/polls/poll_00000000-0000-0000-0000-000000000000/responses?expand%5B%5D=%5B%22post%22%5D")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "GET"
request.allHTTPHeaderFields = headers

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```

### Filtered by post

**Response**

```json
{
  "data": [
    {
      "id": "00000000-0000-0000-0000-000000000010",
      "subscription_deleted": false,
      "poll_choice_id": "00000000-0000-0000-0000-000000000001",
      "created_at": 1666800100,
      "subscription_id": "sub_00000000-0000-0000-0000-000000000001",
      "poll_choice_label": "Red",
      "extended_feedback": "I love red!"
    }
  ],
  "limit": 10,
  "has_more": false,
  "next_cursor": null
}
```

**SDK Code**

```python Filtered by post
import requests

url = "https://api.beehiiv.com/v2/publications/pub_00000000-0000-0000-0000-000000000000/polls/poll_00000000-0000-0000-0000-000000000000/responses"

querystring = {"post_id":"post_00000000-0000-0000-0000-000000000000"}

headers = {"Authorization": "Bearer <token>"}

response = requests.get(url, headers=headers, params=querystring)

print(response.json())
```

```javascript Filtered by post
const url = 'https://api.beehiiv.com/v2/publications/pub_00000000-0000-0000-0000-000000000000/polls/poll_00000000-0000-0000-0000-000000000000/responses?post_id=post_00000000-0000-0000-0000-000000000000';
const options = {method: 'GET', headers: {Authorization: 'Bearer <token>'}};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go Filtered by post
package main

import (
	"fmt"
	"net/http"
	"io"
)

func main() {

	url := "https://api.beehiiv.com/v2/publications/pub_00000000-0000-0000-0000-000000000000/polls/poll_00000000-0000-0000-0000-000000000000/responses?post_id=post_00000000-0000-0000-0000-000000000000"

	req, _ := http.NewRequest("GET", url, nil)

	req.Header.Add("Authorization", "Bearer <token>")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby Filtered by post
require 'uri'
require 'net/http'

url = URI("https://api.beehiiv.com/v2/publications/pub_00000000-0000-0000-0000-000000000000/polls/poll_00000000-0000-0000-0000-000000000000/responses?post_id=post_00000000-0000-0000-0000-000000000000")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Get.new(url)
request["Authorization"] = 'Bearer <token>'

response = http.request(request)
puts response.read_body
```

```java Filtered by post
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.get("https://api.beehiiv.com/v2/publications/pub_00000000-0000-0000-0000-000000000000/polls/poll_00000000-0000-0000-0000-000000000000/responses?post_id=post_00000000-0000-0000-0000-000000000000")
  .header("Authorization", "Bearer <token>")
  .asString();
```

```php Filtered by post
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('GET', 'https://api.beehiiv.com/v2/publications/pub_00000000-0000-0000-0000-000000000000/polls/poll_00000000-0000-0000-0000-000000000000/responses?post_id=post_00000000-0000-0000-0000-000000000000', [
  'headers' => [
    'Authorization' => 'Bearer <token>',
  ],
]);

echo $response->getBody();
```

```csharp Filtered by post
using RestSharp;

var client = new RestClient("https://api.beehiiv.com/v2/publications/pub_00000000-0000-0000-0000-000000000000/polls/poll_00000000-0000-0000-0000-000000000000/responses?post_id=post_00000000-0000-0000-0000-000000000000");
var request = new RestRequest(Method.GET);
request.AddHeader("Authorization", "Bearer <token>");
IRestResponse response = client.Execute(request);
```

```swift Filtered by post
import Foundation

let headers = ["Authorization": "Bearer <token>"]

let request = NSMutableURLRequest(url: NSURL(string: "https://api.beehiiv.com/v2/publications/pub_00000000-0000-0000-0000-000000000000/polls/poll_00000000-0000-0000-0000-000000000000/responses?post_id=post_00000000-0000-0000-0000-000000000000")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "GET"
request.allHTTPHeaderFields = headers

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```